import javax.swing.*;
import javax.imageio.*;
import java.io.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.math.*;

/**
 *
 * @author  Girhiny Rbert
 */

public class MainForm extends JFrame {
    public MainForm() {
        initComponents();
        initFileChooser();
    }
    
/** This method is called from within the constructor to
  * initialize the form.
  * WARNING: Do NOT modify this code. The content of this method is
  * always regenerated by the Form Editor.
  */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        loadImgbt = new javax.swing.JButton();
        estimatebt = new javax.swing.JButton();
        calculatebt = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        origPane = new javax.swing.JScrollPane();
        jLabel1 = new javax.swing.JLabel();
        skelPane = new javax.swing.JScrollPane();
        jLabel2 = new javax.swing.JLabel();
        distPane = new javax.swing.JScrollPane();
        jLabel3 = new javax.swing.JLabel();

        setTitle("Pupil center detection");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel6.setLayout(new java.awt.GridLayout(1, 0));

        loadImgbt.setText("Load image");
        loadImgbt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadImgbtActionPerformed(evt);
            }
        });

        jPanel6.add(loadImgbt);

        estimatebt.setText("Estimate");
        estimatebt.setEnabled(false);
        estimatebt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                estimatebtActionPerformed(evt);
            }
        });

        jPanel6.add(estimatebt);

        calculatebt.setText("Calculate pupil center an radius");
        calculatebt.setEnabled(false);
        calculatebt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                calculatebtActionPerformed(evt);
            }
        });

        jPanel6.add(calculatebt);

        jPanel1.add(jPanel6, java.awt.BorderLayout.NORTH);

        jPanel3.add(jPanel1);

        getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.X_AXIS));

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Original image");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel1.setMaximumSize(new java.awt.Dimension(101, 100));
        jLabel1.setMinimumSize(new java.awt.Dimension(101, 100));
        jLabel1.setPreferredSize(new java.awt.Dimension(116, 100));
        jLabel1.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        origPane.setViewportView(jLabel1);

        jPanel2.add(origPane);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Estimated pupil center ");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel2.setMaximumSize(new java.awt.Dimension(109, 100));
        jLabel2.setMinimumSize(new java.awt.Dimension(109, 100));
        jLabel2.setPreferredSize(new java.awt.Dimension(109, 80));
        jLabel2.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        skelPane.setViewportView(jLabel2);

        jPanel2.add(skelPane);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setText("Pupil center and radius");
        jLabel3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel3.setMaximumSize(new java.awt.Dimension(109, 100));
        jLabel3.setMinimumSize(new java.awt.Dimension(109, 100));
        jLabel3.setPreferredSize(new java.awt.Dimension(109, 100));
        jLabel3.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        distPane.setViewportView(jLabel3);

        jPanel2.add(distPane);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    private int width,height; // a kp szlessge s hossza
    private BufferedImage Oimg; // Eredeti kp (original image)
    private BufferedImage Himg; // H csatorns kp (H chanel image)
    private BufferedImage Gimg; // szrkeskls kp (Gray scaled image)
    int[] RGBpixels; // az eredeti kp RGB pontjai
    int[] Hpixels; // a H csatorns kp pontjai
    int[] Gpixels; // a szrke skls kp pontjai
    int ex,ey; // a pupilla kzppontja
    int r; // a pupilla sugara
    
    private double sqr(double d) {
        return d*d;
    }
    
    private int calcint(int x, int y, int r) {
        int xx,yy,y1,y2,x1,x2,i,count,avarage;
        
        i=-1; count=0;        
        if (y-r>0) y1=y-r; else y1=0;
        if (y+r>height) y2=height-1; else y2=y+r;
        if (x-r>0) x1=x-r; else x1=0;
        if (x+r>width) x2=width-1; else x2=x+r;
        
        avarage=-1;
        for (yy=y1; yy<y2; yy++)
            for (xx=x1; xx<x2; xx++)
                if ( Math.sqrt(sqr(xx-x)+sqr(yy-y))<r ) {
                    avarage += (Gpixels[xx+yy*width] & 0xff);
                    count++;
                }
        avarage=avarage / count;
        for (yy=y1; yy<y2; yy++)
            for (xx=x1; xx<x2; xx++)
                if (Math.sqrt(sqr(xx-x)+sqr(yy-y))<r)
                    if ( (Gpixels[xx+yy*width] & 0xff) >= avarage ) i++;
        return i;
    }
       
    private void move() {
        int x,y,xx,yy,min;
        xx=-1; yy=-1;
        min=calcint(ex-10,ey-10,r);
        for (x=ex-8; x<ex+8; x++)
            for (y=ey-8; y<ey+8; y++)
                if (calcint(x,y,r)<min) {
                    min = calcint(x,y,r);
                    if (x+r<width && x-r>0 && y+r<height && y-r>0) {
                        xx=x;
                        yy=y;
                    }
                }
        ex = xx;
        ey = yy;
    }
    
    private void middlefilter() {
       int[] Tpixels = new int[width*height];
       for (int y=1; y<height-1; y++)            
            for (int x=1; x<width-1; x++) {
                int b=0;
                
                b=b+(Gpixels[x+y*width] & 0xff);
                b=b+(Gpixels[x+(y-1)*width] & 0xff);
                b=b+(Gpixels[x+(y+1)*width] & 0xff);
                
                b=b+(Gpixels[x+1+y*width] & 0xff);
                b=b+(Gpixels[x+1+(y-1)*width] & 0xff);
                b=b+(Gpixels[x+1+(y+1)*width] & 0xff);
                
                b=b+(Gpixels[x-1+y*width] & 0xff);
                b=b+(Gpixels[x-1+(y-1)*width] & 0xff);
                b=b+(Gpixels[x-1+(y+1)*width] & 0xff);
                
                b=b/9;
                Tpixels[x+y*width] = (b << 16) | (b << 8) | b;                   
            }
       for (int i=0; i<width*height; i++) Gpixels[i] = Tpixels[i];
                      
       Gimg.setRGB(0, 0, width, height, Gpixels, 0, width);       
       jLabel3.setIcon(new ImageIcon(Gimg));
    }
    
    
private void calculatebtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_calculatebtActionPerformed
      r = 10;
      int act;
      
      middlefilter();
      
      move();
      
      for (int ri=r; ri<60; ri++)
          if (calcint(ex,ey,ri)<=2000) {
            r = ri;
            act = calcint(ex,ey,r);
          }
     
      //System.out.println(r);
      
      Gimg.getGraphics().drawLine(ex-1,ey,ex+1,ey);
      Gimg.getGraphics().drawLine(ex,ey-1,ex,ey+1);
      Gimg.getGraphics().drawOval(ex-r/2,ey-r/2,r,r);
      jLabel3.setIcon(new ImageIcon(Gimg));
}//GEN-LAST:event_calculatebtActionPerformed


private void estimatebtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_estimatebtActionPerformed
       int intensity;
       int maxintensity =0;
       int lx=0,ly=0; // csak a rajzolshoz kell
       ex=-1; ey=-1;
    
       for (int y=1; y<height; y++) {
            intensity = 0;
            for (int x=1; x<width; x++)               
                intensity += Hpixels[x+y*width];
            
            // hisztogramm rajzols
            /*Himg.getGraphics().drawLine(intensity % (width/8),y,lx,ly);
            lx=(intensity % (width/8));
            ly=y;*/
            
            if (intensity > maxintensity) {
                maxintensity = intensity;
                ey = y;
            }
       }
       
       lx=0; ly=0;
       maxintensity =0;
       for (int x=1; x<width; x++) {
            intensity = 0;
            for (int y=1; y<height; y++)           
                intensity += Hpixels[x+y*width];
            
            // hisztogramm rajzols
            /*Himg.getGraphics().drawLine(x,intensity % (height/4),lx,ly);
            lx = x;
            ly = (intensity % (height/4));*/
            
            if (intensity > maxintensity) {
                maxintensity = intensity;
                ex = x;
            }
       }
       

       Himg.getGraphics().setColor(Color.red);
       Himg.getGraphics().drawLine(ex-1,ey,ex+1,ey);
       Himg.getGraphics().drawLine(ex,ey-1,ex,ey+1);
       Himg.getGraphics().drawOval(ex-10,ey-10,20,20);             
       jLabel2.setIcon(new ImageIcon(Himg));              
}//GEN-LAST:event_estimatebtActionPerformed

    private JFileChooser fc;
    
    private void initFileChooser() {
        fc=new JFileChooser();
        fc.addChoosableFileFilter(
        new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                if (f.isDirectory()) return true;
                
                String name=f.getName();
                int pos=name.lastIndexOf('.');
                if (pos==-1) return false;
                
                return name.substring(pos+1).toLowerCase().equals("png");
                }
            
            public String getDescription() {
                return "PNG only";
            }
        }
            );
    }
    
  
    // az r,g,b sznekbl ellltja a neki megfelel H csatornt 
    private int splitHchanel(int r, int g, int b) {
		
		int min;    //Min. value of RGB
		int max;    //Max. value of RGB
		int delMax; //Delta RGB value               
                
		if (r > g) { min = g; max = r; }
		else { min = r; max = g; }
		if (b > max) max = b;
		if (b < min) min = b;
                delMax = max - min;

		float H = 0, S;
		float V = max;
		   
		if ( delMax == 0 ) { H = 0; S = 0; }
		else {                                   
			S = delMax/255f;
			if ( r == max ) 
				H = (      (g - b)/(float)delMax)*60;
			else if ( g == max ) 
				H = ( 2 +  (b - r)/(float)delMax)*60;
			else if ( b == max ) 
				H = ( 4 +  (r - g)/(float)delMax)*60;   
		}
		
                return (int)(H);
	}

    
    
    private void loadImgbtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadImgbtActionPerformed
        // Eredeti kp betltse
        if (fc.showOpenDialog(this)!=fc.APPROVE_OPTION) return;
        try {
        Oimg=ImageIO.read(fc.getSelectedFile());
        }
        catch (Exception e) { return; }
        
        width = Oimg.getWidth();
        height = Oimg.getHeight();
        
        // kppontok ltrehozsa
        RGBpixels=Oimg.getRGB(0, 0, width, height, null, 0, width);
        Hpixels = new int[width*height];
        Gpixels = new int[width*height];     
            
        for (int i=0; i<width*height; i++) {
            int r = (RGBpixels[i] >> 16) & 0xff;
            int g = (RGBpixels[i] >> 8 ) & 0xff;
            int b = (RGBpixels[i] >> 0 ) & 0xff;
            
            // a H csatorns kppontok kiszmtsa
            int h = splitHchanel(r,g,b);
            Hpixels[i]= (h << 16) | (h << 8) | (h << 0);
            
            // a szrke skls kppontok kiszmtsa
            int delta = (r+g+b) / 3;           
            Gpixels[i]= (delta << 16) | (delta << 8) | (delta << 0);
        }
        
        // a H csatorns kp ltrehozsa
        Himg=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB); 
        Himg.setRGB(0, 0, width, height, Hpixels, 0, width);     
        
        // a szrke skls kp ltrehozsa
        Gimg=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB); 
        Gimg.setRGB(0, 0, width, height, Gpixels, 0, width);     
        
  
        // kpek megjelentse
        jLabel1.setIcon(new ImageIcon(Oimg));
        jLabel2.setIcon(new ImageIcon(Himg));
        jLabel3.setIcon(new ImageIcon(Gimg));
   
        // nyomgombok engedlyezse
        estimatebt.setEnabled(true);
        calculatebt.setEnabled(true);
    }//GEN-LAST:event_loadImgbtActionPerformed
    
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new MainForm().show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton calculatebt;
    private javax.swing.JScrollPane distPane;
    private javax.swing.JButton estimatebt;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JButton loadImgbt;
    private javax.swing.JScrollPane origPane;
    private javax.swing.JScrollPane skelPane;
    // End of variables declaration//GEN-END:variables
    
}
